"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GetPurposesAndVendorsUseCase = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GetPurposesAndVendorsUseCase = exports.GetPurposesAndVendorsUseCase = function () {
  function GetPurposesAndVendorsUseCase(_ref) {
    var repository = _ref.repository;
    (0, _classCallCheck3.default)(this, GetPurposesAndVendorsUseCase);

    this._repository = repository;
  }

  (0, _createClass3.default)(GetPurposesAndVendorsUseCase, [{
    key: "execute",
    value: function execute() {
      var _this = this;

      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          retrieveConsentsFromCmp = _ref2.retrieveConsentsFromCmp;

      return _promise2.default.resolve(retrieveConsentsFromCmp).then(function (retrieve) {
        return retrieve ? _this._loadStoredConsents() : _this._loadDefaultConsents();
      });
    }
  }, {
    key: "_loadStoredConsents",
    value: function _loadStoredConsents() {
      return _promise2.default.all([this._repository.getPurposesAndVendors(), this._repository.getVendorConsents()]).then(function (_ref3) {
        var _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
            purposesAndVendors = _ref4[0],
            consents = _ref4[1];

        return (0, _extends3.default)({}, purposesAndVendors, {
          purposeConsents: consents.purposeConsents,
          vendorConsents: consents.vendorConsents
        });
      });
    }
  }, {
    key: "_loadDefaultConsents",
    value: function _loadDefaultConsents() {
      var _this2 = this;

      return this._repository.getPurposesAndVendors().then(function (purposesAndVendors) {
        return (0, _extends3.default)({}, purposesAndVendors, _this2._generateDefaultConsentsObject(purposesAndVendors));
      });
    }
  }, {
    key: "_generateConsent",
    value: function _generateConsent(_ref5) {
      var list = _ref5.list;

      return list.reduce(function (acc, _ref6) {
        var id = _ref6.id;

        acc[id.toString()] = true;
        return acc;
      }, {});
    }
  }, {
    key: "_generateDefaultConsentsObject",
    value: function _generateDefaultConsentsObject(_ref7) {
      var purposes = _ref7.purposes,
          vendors = _ref7.vendors;

      return {
        purposeConsents: this._generateConsent({ list: purposes }),
        vendorConsents: this._generateConsent({ list: vendors })
      };
    }
  }]);
  return GetPurposesAndVendorsUseCase;
}();